/*
	CingularMinutesMinder
	cingular.js
	Author: Matt Zollinhofer
	Date: 9/1/06
	Version: 0.6
	cingularminutes@gmail.com
	
	Thanks:
		- Winston Huang, parts of this extension based on his T-Mobile extension.
		- Steve Gula for fixing my stupidity
		- Chris Tilden for family plan regex help
	
	License:
	  Permission is hereby granted, free of charge, to any person obtaining
      a copy of this software and associated documentation files (the
      "Software"), to deal in the Software without restriction, including
      without limitation the rights to use, copy, modify, merge, publish,
      distribute, sublicense, and/or sell copies of the Software, and to
      permit persons to whom the Software is furnished to do so, subject to
      the following conditions:
      
      The above copyright notice and this permission notice shall be
      included in all copies or substantial portions of the Software.
      
      THE SOFTWARE IS PROVIDED "AS IS", WITHnOUT WARRANTY OF ANY KIND,
      EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
      MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
      NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
      LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
      OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
      WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
      	
*/

var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
var cingularPrefVal = "http://minuteMinder.cingular.com";
var loginRequest;
var minutesRequest;
var ASYNC = true;
var number = "";
var areaCode = "";
var prefix = "";
var lastFour = "";
var alreadyPromptedForPassword = false;
var alreadyPromptedForPasscode = false;
var loginTimeout = null;

var minutesHTML="";
var txtMsgHTML="";
var numLines = 0;
var nextCycleDate;

function cingularInit() 
{
	window.addEventListener( "load", windowLoad, false );
}

/*
	Executed anytime a new Firefox window is opened.
	Checks the last checked date, if old, recheck,
	otherwise just use the value stored.
*/
function windowLoad()
{
/*	clear();
	print("Cingular Testing\n----------------------")
	testCingular();
	return '';
*/

	if ( prefs.getPrefType("extensions.cingularMinutesMinder.statusBarTypeToDisplay") != prefs.PREF_STRING )
	{
		prefs.setCharPref("extensions.cingularMinutesMinder.statusBarTypeToDisplay", 'anytime');
	}
	
	if ( prefs.getPrefType("extensions.cingularMinutesMinder.statusBarVerbose") != prefs.PREF_BOOL )
	{
		prefs.setBoolPref("extensions.cingularMinutesMinder.statusBarVerbose", false);
	}
	
	if ( getCingularLoginData() )
	{
//		var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
		//if we have some minute information saved, use it while we try to download it
		if ( (prefs.getPrefType("extensions.cingularMinutesMinder.minutesRemaining") == prefs.PREF_STRING)
				&& (prefs.getCharPref("extensions.cingularMinutesMinder.minutesRemaining")) )
		{
			var minRemainingLabel = document.getElementById('cingularMinutesRemaining');
			if (minRemainingLabel)
			{
				minRemainingLabel.value = prefs.getCharPref("extensions.cingularMinutesMinder.minutesRemaining");
			}
		}
		getCingularInformation();
	}
/*	else
	{
		setCingularLabel("No login data")
	}
*/
}

/*
	1. get the number and password
	2. break the number up into pieces
	3. get the last time checked from firefox's user prefs (about:config)
	4. set loading image
	5. set last time checked
	6. send initial request
*/
function getCingularInformation()
{
	var data = getCingularLoginData();
	if ( data )
	{
		number = data.login;
		areaCode = number.substring(0,3);
		prefix = number.substring(3,6);
		lastFour = number.substring(6,10);

//		var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
		var today = new Date();
		var lastChecked;

		try
		{
			if (prefs.getPrefType("extensions.cingularMinutesMinder.lastTimeChecked") == prefs.PREF_STRING
				&& prefs.getCharPref("extensions.cingularMinutesMinder.lastTimeChecked") )
			{
				lastChecked = prefs.getCharPref("extensions.cingularMinutesMinder.lastTimeChecked");
			}
		}
		catch( err )
		{
			prefs.deleteBranch("extensions.cingularMinutesMinder.lastTimeChecked");
		}
		
		//only allow the extension to check itself every 10 minutes
		//TODO: make the 10 minutes configurable
		if ( (lastChecked == null) || (lastChecked < today.getTime()) )
		{
			var image = document.getElementById("cingularImage");
			image.src="chrome://cingularminutes/content/loading.gif";

			//set the preference to save right now plus 60 min so you can only check once an hour
			prefs.setCharPref("extensions.cingularMinutesMinder.lastTimeChecked", today.getTime()+3600000 );
/*			prefs.setCharPref("extensions.cingularMinutesMinder.lastTimeChecked", today.getTime()-1 );*/

			loginRequest = new XMLHttpRequest();
			loginRequest.open("POST", "https://www.cingular.com/olam/loginAction.doview", ASYNC);
			loginRequest.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
			if (ASYNC)
			{
				loginRequest.onload = getMinutesInformation;
			}
		
			var req;
			//the old login process
			//req="actionEvent=loginInProgress&IDToken1="+number+"&ctnAreaCode="+areaCode+"&ctnPrefix="+prefix+"&ctnNumber="+lastFour+"&pass="+data.password+"&x=0&y=0";
			req="actionEvent=loginInProgress&wireless_num="+data.login+"&pass="+data.password+"&x=26&y=9";
			loginRequest.send(req);
			loginTimeout = setTimeout(countDown,120000);  //timeout is 2 minutes, Cingular is slow is that long enough?
		}
		else
		{
			try
			{
				if ( prefs.getPrefType("extensions.cingularMinutesMinder.minutesRemaining") == prefs.PREF_STRING );
				{
					setCingularLabel( prefs.getCharPref("extensions.cingularMinutesMinder.minutesRemaining") );
				}
			}
			//delete minutesRemaining branch because there is an error with it
			catch( err )
			{
				prefs.deleteBranch("extensions.cingularMinutesMinder.minutesRemaining");
			}
		}

	}
	else
	{
		if ( !alreadyPromptedForPassword )
		{
			alreadyPromptedForPassword = true;
			window.open("chrome://cingularminutes/content/cingularPreferences.xul", "Preferences", "chrome,centerscreen,modal");
			getCingularInformation();
		}
		else
		{
			alreadyPromptedForPassword = false;
		}
	}
}


/* 
	cingular's login process is two steps,
	this method handles the response to the first
	step.  It immediately sends another request which
	brings us to the right page, this is handled 
	in the 'handleMinutesResponse()' function
*/
function getMinutesInformation()
{
	var req;
	minutesRequest = new XMLHttpRequest();
	
	//getting minutes
	minutesRequest.open("POST", "https://www.cingular.com/olam/loginAction.action", ASYNC);
	req="actionEvent=login&reportActionEvent=A_LGN_LOGIN_SUB&ctnAreaCode="+areaCode+"&ctnPrefix="+prefix+"&ctnNumber="+lastFour+"&customerType=";
	minutesRequest.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
	if (ASYNC)
	{
		minutesRequest.onload = getTxtMsgInformation;
	}
	minutesRequest.send(req);
	
}

function testCingular () {
//	getTxtMsgInformation();
}

function getTxtMsgInformation()
{
	//save off the minutesHTML to be parsed later
	minutesHTML = minutesRequest.responseText;
	
	//some accounts have an additional passcode associated with them
	//this if is to accommodate those accounts
	if (minutesHTML.indexOf("Confirm Your Passcode") > -1)
	{
		var passcodeData = getCingularSecurityPasscode();
		if ( !passcodeData )
		{
			if ( !alreadyPromptedForPasscode )
			{
				alreadyPromptedForPassword = true;
				window.open("chrome://cingularminutes/content/cingularAdditionalSecurity.xul", "Additional Security", "chrome,centerscreen,modal");
			}
			else
			{
				alreadyPromptedForPasscode = false;
			}
		}
		
		var passcodeData = getCingularSecurityPasscode();
		if ( passcodeData )
		{
			var req;
			minutesRequest = new XMLHttpRequest();

			//getting minutes
			minutesRequest.open("POST", "https://www.cingular.com/olam/passcodeAction.doview", ASYNC);
			req="passcodeActionEvent=submitPasscode&reportActionEvent=A_LGN_ENTER_PASSCODE_SUB&updateSecretQuestion=&updateSecretAnswer=&passcode="+passcodeData.passcode+"&x=46&y=12";
			minutesRequest.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
			if (ASYNC)
			{
				minutesRequest.onload = getTxtMsgInformation;
			}
			minutesRequest.send(req);
		}
		else
		{
			resetImage();
			setCingularLabel("Problem With Security Passcode");
		}
	}
	else if ( isValidResponse( minutesHTML ) )
	{
		nextCycleDate = getNextCycleDate(minutesHTML);
		numLines = howManyLines(minutesHTML);

		var req;
		minutesRequest = new XMLHttpRequest();
	
		//getting data instead of minutes
		minutesRequest.open("POST", "https://www.cingular.com/olam/dashboardAction.doview", ASYNC);
		// Steve's Fix
		req="reportActionEvent=A_UMD_DATA_SUMMARY&dashboardActionEvent=dataSummary&clickedCtn=&voiceSelectedCtn=Multi_Line_"+areaCode+"-"+prefix+"-"+lastFour;

		//maybe should switch to getting this details page by default
/*		minutesRequest.open("POST", "https://www.cingular.com/olam/gotoUsageSummary.olamexecute", ASYNC);*/
/*		req="reportActionEvent=A_UMD_CURRENT_USAGE_SUMMARY";*/

		minutesRequest.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
		if (ASYNC)
		{
			minutesRequest.onload = handleTxtMsgResponse;
		}
		minutesRequest.send(req);
	}
	else
	{
		resetImage();
		setCingularLabel("Could not login to Cingular");
	}
}

//This should be the last of the information we need. 
//now we start extractingthe data
function handleTxtMsgResponse()
{
	txtMsgHTML = minutesRequest.responseText;
	//if there are more than one line use the extractFamData
	//otherwise use the extractSingleLineData to get the info
	var dataArray = ( numLines > 1 ) ? extractMultipleLineData() : extractSingleLineData();

	//create and display the information
	displayData( dataArray );
}

function extractSingleLineData()
{
	var tableHTML = getDataTableFromHTML(minutesHTML, '<h2>CURRENT USAGE</h2>');
	var minutesDataArray = getDataArrayFromTable(tableHTML);
	var SMSTableHTML = getDataTableFromHTML(txtMsgHTML, '<h2>CURRENT USAGE</h2>');
	var txtMsgDataArray = getDataArrayFromTable(SMSTableHTML);
	var dataArray = minutesDataArray.concat(txtMsgDataArray);
	
	return dataArray;
}	

function extractMultipleLineData()
{
	var newHTML = minutesHTML.substring(minutesHTML.indexOf('<h2>GROUP/CURRENT USAGE</h2>'))
	var tableHTML = getDataTableFromHTML(newHTML, '<div id="tab">');
	var minutesDataArray = getDataArrayFromTableForFam(tableHTML);
	var SMSTableHTML = getDataTableFromHTML(txtMsgHTML, '<h2>CURRENT USAGE</h2>');
	var txtMsgDataArray = getDataArrayFromTable(SMSTableHTML);
	var dataArray = minutesDataArray.concat(txtMsgDataArray);
	
	return dataArray;
}

function displayData( dataArray )
{
	if ( dataArray )
	{
		var displayType = prefs.getCharPref("extensions.cingularMinutesMinder.statusBarTypeToDisplay");
		var statusDisplay = "";
		//this is what we display on the status bar
		for ( var i=0; i<dataArray.length; i++)
		{
			var rowArray = dataArray[i];
			if ( rowArray[0] && rowArray[0].toLowerCase().indexOf(displayType) > -1 )
			{
				statusDisplay = rowArray[3];
				totalAllowed = rowArray[2];
				
				if ( prefs.getBoolPref("extensions.cingularMinutesMinder.statusBarVerbose") == true )
				{
					statusDisplay += " " + (( displayType == "anytime") ? "Anytime Minutes" : "Text Messages") + " Remaining";
				}
			}
		}

		//set the status bar display text
		setCingularLabel( statusDisplay );
		//if the 'remaining' value is a number
		//and if it is anytime minutes < 60 
		//or it's sms messages < 10
		//we want to mark it as low (red)
		if ( (""+parseInt(statusDisplay)!="NaN") && 
				(((displayType=='anytime') && (statusDisplay<(totalAllowed*.1))) ||
				 ((displayType=!'anytime') && (statusDisplay<(totalAllowed*.1)))) )
		{
			//TODO: change this if to 10% of the total allowed for anytime or sms rather than static value
			setDataAsLow();
		}
		prefs.setCharPref("extensions.cingularMinutesMinder.minutesRemaining", statusDisplay);
		//TODO: set both minutes and sms info instead of storing sms on top of minutesRemaining
		
		
		//set the tooltip
		var toolTip = createToolTip ( dataArray );
		setCingularToolTip(toolTip);
	}

	resetImage();
	
}

function resetImage()
{
	// stop the loading image, put it back to the Cingular image
	var image = document.getElementById("cingularImage");
	image.src="chrome://cingularminutes/content/cingularSmall.png";
	if ( loginTimeout )
	{
		clearTimeout(loginTimeout);
	}
	
}

function clearCingularCache()
{
	prefs.deleteBranch("extensions.cingularMinutesMinder.lastTimeChecked");
	prefs.deleteBranch("extensions.cingularMinutesMinder.minutesRemaining");
}

function isValidResponse( html )
{
	var test = getNextCycleDate( html );
	return ( test != "" )
}

function howManyLines( html )
{
	var regex = new RegExp("Wireless Numbers on Account:\\s*</strong>\\s*([0-9]+)");
	var match = regex.exec(html);
	return match[1];
}

function getNextCycleDate (html) 
{
	var regex = new RegExp("Next Bill Cycle:\s*</strong>\\s*</td>\\s*<td.*?>\\s*([0-9][0-9]?[/-\\\\.][0-9][0-9]?[/-\\\\.][0-9][0-9][0-9]?[0-9]?)");
	var match = regex.exec(html);
	if ( match )
		return match[1];
	else
		return "";
}

function getDataTableFromHTML(html, marker)
{
	var idx1;
	var tableStartIdx, tableEndIdx;
	var rtnVal = null;
	
	//the marker gives us a place to start looking for the first table
	//if it's not there we just start at the beginning
	idx1 = ( marker != null ) ? html.indexOf(marker) : 0;
	
	if ( idx1 > -1 )
	{
		html = html.substring(idx1);
		tableStartIdx = html.indexOf('<table');
		tableEndIdx = html.indexOf('</table>');
		rtnVal = html.substring(tableStartIdx, tableEndIdx+7);
	}
	
	return rtnVal;
}

function getDataArrayFromTableForFam(table)
{
	var toolTipArray = null;
	var rowArray;
	
	if ( table )
	{
		var rows = getRows(table);  //rows from the table with the data (minutes or text message)
		toolTipArray = new Array();
		
		//start at 3 because the few rows aren't info we need
		//and the last row seems to just be a spacer
		for ( var i=3; i < rows.length-1; i++ )
		{
			rowArray = new Array();
			var thisRow = cleanUpData(rows[i]);

			var regex = new RegExp("<td[\\s\\S]*?><a[\\s\\S]*?>([\\s\\S]*?)</a>[\\s\\S]*?</td>[\\s\\S]*?<td[\\s\\S]*?>([\\s\\S]*?)</td>[\\s\\S]*?<td[\\s\\S]*?>([\\s\\S]*?)</td>[\\s\\S]*?<td[\\s\\S]*?>([\\s\\S]*?)</td>");
			var matcher = regex.exec(thisRow);
			if ( matcher != null )
			{
				rowArray[0] = matcher[1];  //type of minutes
				rowArray[1] = matcher[3];  //family minutes used
				rowArray[2] = ((""+parseInt(matcher[4]))=="NaN") ? matcher[4] : (parseInt(matcher[4]) + (parseInt(matcher[3])));  
				rowArray[3] = matcher[4];
				toolTipArray[toolTipArray.length] = rowArray;
			}
		}
	}
	return toolTipArray;
}

function getDataArrayFromTable(table)
{
	var toolTipArray = null;
	var rowArray = new Array();
	
	if ( table )
	{
		var rows = getRows(table);  //rows from the table with the data (minutes or text message)
		rowCount = 1;
		toolTipArray = new Array();
		
		//don't start at 0 because the first row is just a link
		//after that every 3 rows make up one type of service
		for ( var i=1; i < rows.length; i++ )
		{
			if ( rowCount == 1 )
			{
				rowArray = new Array();
			}
			switch (rowCount)
			{
				//the first row has the minute type (Anytime, Nights/Weekends, etc.)
				case 1:
					var minuteType = getMinuteType(rows[i]);
					rowArray[0] = minuteType;
					break;
					
				//second row is the graph, maybe useful later
				case 2:
					break;
				
				//third row has the number of minutes used and total number of minutes
				case 3:
					var minuteData = getMinuteData(rows[i]);
					if ( minuteData )
					{
						rowArray[1] = minuteData[1];
						rowArray[2] = minuteData[2];
						rowArray[3] = minuteData[3];
					}
					rowCount = 0;
					break;
			}
			
			//if the length is 4, then we have a full array for the toolTipArray
			//until it gets to 4 it's still building the data
			if ( rowArray.length == 4 )
			{
				toolTipArray[toolTipArray.length] = rowArray;
			}
			rowCount++;
		}
		
	}
		return toolTipArray;
}

function getMinuteType( row )
{
	var regStr = "<td[\\s\\S]*?>([\\s\\S]*?)</td>";
	var regExp = new RegExp(regStr);
	var cellData = regExp.exec(row);
	var minuteType = "";
	if ( cellData )
	{
		minuteType = cellData[1];
		minuteType = removeEncodedAnd( minuteType );
		minuteType = stripAnchor( minuteType );
	}
	return minuteType;
}

function getMinuteData( data )
{
	var rowArray = new Array();
	var regStr = "<td[\\s\\S]*?>([\\s\\S]*?)</td>";
	var regExp = new RegExp(regStr);
	var cellData = regExp.exec(data);
	if ( cellData )
	{
		//take all the commas out of the numbers
		//TODO: use clearUpData instead of these two lines
		var data = cellData[1].replace(",","");
		data = data.replace("&nbsp;","");

		//minutes will have all the numbers out the cellData
		regStr = "\\s([\\d.]+)";
		var minutes = getAllMatches(data+" ", regStr);
		var remainingMinutes = "";
		switch (minutes.length)
		{
			//if there are 0 numbers, don't do anything
			case 0:
				rowArray[1] = rowArray[2] = rowArray[3] = "";
				break;
				
			//if there is 1 number, check to see if it's unlimited or n/a, if not don't do anything
			case 1:
				if ( data.toLowerCase().indexOf('unlimited') > -1 )
					remainingMinutes = "Unlimited";
				else if ( data.toLowerCase().indexOf('n/a') > -1 )
					remainingMinutes = "N/A";
					
				rowArray[1] = minutes[0];
				rowArray[2] = rowArray[3] = remainingMinutes;
				break;
				
			//if there are 2 numbers, subtract them to get the number of remaining minutes
			case 2:
				remainingMinutes = (minutes[1]-minutes[0]);
				rowArray[1] = minutes[0];
				rowArray[2] = minutes[1];
				rowArray[3] = remainingMinutes;
				break;
				
		}
//						toolTipText += remainingMinutes+"\n";
	}
	return rowArray;
}

/*
	Returns an array of the strings in str that matched the string regStr
*/
function getAllMatches(str, regStr)
{
	var allMatches = new Array();
	regExp = new RegExp(regStr);
	var idx = 0;

	while ( idx > -1 )
	{
		match = regExp.exec(str);
		if ( match != null )
		{
			idx = match.index;
			allMatches[allMatches.length] = match[1];
			str = str.substring( idx+match[0].length-1 );
		}
		else
		{
			idx = -1;
		}
	}
	return allMatches;
}

/*removes all commas and &nbsp; and html comments*/
function cleanUpData( str )
{
	if ( str )
	{
		var temp = "";
		temp = str.replace(new RegExp("([0-9]),([0-9])","g"),"$1$2");
		temp = temp.replace(new RegExp("&nbsp;","g"),"");
		temp = temp.replace(new RegExp("\\n","g"),"");
		temp = temp.replace(new RegExp("\\s+","g")," ");
		return temp;
	}
	return '';
}

/*
	returns an array of the data inside the <tr>s that are passed to it
*/
function getRows(text)
{
	var rows = new Array();
	var count = 0;
	var idx = text.indexOf('<tr>');
	while ( idx > -1 )
	{
		rows[count] = text.substring(text.indexOf('<tr>')+5, text.indexOf('</tr>', text.indexOf('<tr>')+5) );
		count++;
		text = text.substring(idx+1);
		idx = text.indexOf('<tr>');
	}
	
	return rows;
}


/*
	strips all non-digit characters and sets the userID/password
	in FF password manager
*/
function setCingularLoginData( userID, password )
{

	var userID = userID.replace(new RegExp("[^0-9]","g"),"");
	var passMgr = Components.classes["@mozilla.org/passwordmanager;1"].getService(Components.interfaces.nsIPasswordManagerInternal);
	try 
	{
		passMgr.addUserFull( cingularPrefVal, userID, password, '', '', '');
	} 
	catch (err) 
	{
		setCingularLabel( "Didn't save login data." );
		return false;
	}
	return true;
}

/*
	gets userID and password from FF's password manager
*/
function getCingularLoginData()
{
    var data = {login: "", password: ""};
	var host = {value: "http://minuteMinder.cingular.com"}, user = {value: ""}, password = {value: ""};

	var mypassMgr = Components.classes["@mozilla.org/passwordmanager;1"].getService(Components.interfaces.nsIPasswordManagerInternal);
	try 
	{
		mypassMgr.findPasswordEntry( host.value, '', '', host, user, password ); 
		data.login = user.value;
		data.password = password.value;
	} 
	catch (err) 
	{
		setCingularLabel( "No login/password saved." );
		return false;
	}

	return data;
}

/*
	gets userID and password from FF's password manager
*/
function getCingularSecurityPasscode()
{
    var data = {login: "", passcode: ""};
	var host = {value: "http://minuteMinderPasscode.cingular.com"}, user = {value: ""}, passcode = {value: ""};

	var mypassMgr = Components.classes["@mozilla.org/passwordmanager;1"].getService(Components.interfaces.nsIPasswordManagerInternal);
	try 
	{
		mypassMgr.findPasswordEntry( host.value, '', '', host, user, passcode ); 
		data.login = user.value;
		data.passcode = passcode.value;
	} 
	catch (err) 
	{
		setCingularLabel( "No Security Passcode Saved." );
		return false;
	}

	return data;
}

function setDataAsLow () 
{
	try
	{
		var label = document.getElementById("cingularMinutesRemaining");
		label.setAttribute('class', label.getAttribute('class')+' low');
		return true;
	}
	catch (err)
	{
		return false;
	}
}

function setCingularLabel( labelMessage )
{
	try
	{
		var label = document.getElementById("cingularMinutesRemaining");
		label.value = labelMessage;
		return true;
	}
	catch (err)
	{
		return false;
	}
}
function setCingularToolTip ( tooltip )
{
	try
	{
		mainPopup = document.getElementById("mainPopupSet");
		mainPopup.appendChild(tooltip);
		var statusPanel = document.getElementById('cingularStatusPanel');
		statusPanel.setAttribute('tooltip', tooltip.id);
		return true;
	}
	catch( err )
	{
		return false;
	}
}

function createErrorToolTip( errorString )
{
	var box = document.createElement("box");
	var label = document.createElement("label");
	label.value = "error String please show up";
	label.setAttribute("class", "error");
	label.width = 150;
	label.height = 40;
	box.appendChild(label);
	var tooltip = document.createElement("tooltip");
	tooltip.setAttribute("id", "cingularErrorToolTip");
	tooltip.setAttribute("autohide", false);
	tooltip.appendChild(box);
	return tooltip;
}

function createToolTip( dataArray )
{
//	alert('started setting tooltip');
	var grid = document.createElement("grid");
	grid.setAttribute("id","cingularToolTipGrid");
	
	//create and append columns
	var columns = createColumns();
	grid.appendChild(columns);
	
	//create and append heading
	var rows = document.createElement("rows");
	var minuteHeadingRow = createMinuteHeadingRow();
	rows.appendChild(minuteHeadingRow);

/*
	//test dataArray
	var dataArray = new Array(
								new Array("Anytime","350","900","600"), 
								new Array("Mobile To Mobile","299","1000","701"),
								new Array("Nights & Weekends","252","Unlimited","Unlimited"),
								new Array("Overage","252","N/A","N/A")
							 );
*/
	//create and append data rows
	var minuteDataRows = createMinuteDataRows(dataArray);
	for ( var i=0; i<minuteDataRows.length; i++ )
	{
		rows.appendChild(minuteDataRows[i]);
	}
	grid.appendChild(rows);
	var nextCycleLabel = createNextCycle(nextCycleDate);

	var tooltip = getFreshTooltip();
	
	tooltip.appendChild(grid);
	tooltip.appendChild(nextCycleLabel);
	return tooltip;
}

function getFreshTooltip () 
{
	var tooltip = document.getElementById('cingularToolTip');

	if (tooltip == null)
	{
		tooltip = document.createElement('tooltip');
		tooltip.setAttribute('id','cingularToolTip');
		tooltip.setAttribute("noautohide", true);
		tooltip.setAttribute("orient", "vertical");
	}
	else
	{
		while (tooltip.hasChildNodes())
		{
			tooltip.removeChild( tooltip.firstChild );
		}
	}
	return tooltip;
}

/*this isn't used, probably need to get rid of it*/
function createPlanType () {
	var planType = document.createElement('label');
	planType.setAttribute("value","Group Plan");
	planType.setAttribute("id","planType");
	return planType;
}

function createNextCycle (date) {
	if (date)
	{
		var nextCycle = document.createElement('label');
		nextCycle.setAttribute("value","Next Bill Cycle: "+date);
		nextCycle.setAttribute("id","nextCycle");
		return nextCycle;
	}
	return;
}

function createColumns()
{
	var columns = document.createElement("columns");
	var column1 = document.createElement("column");
	var column2 = document.createElement("column");
	var column3 = document.createElement("column");
	var column4 = document.createElement("column");
	column1.setAttribute("flex","1");
	columns.appendChild(column1);
	columns.appendChild(column2);
	columns.appendChild(column3);
	columns.appendChild(column4);
	return columns;
}

function createMinuteHeadingRow()
{
	var headingRow = document.createElement("row");
	headingRow.setAttribute("class","headingRow");
	var heading1 = document.createElement('label');
	heading1.setAttribute("value","Types");
	heading1.setAttribute('class','heading typesHeading');
	var heading2 = document.createElement('label');
	heading2.setAttribute("value","Used");
	heading2.setAttribute('class','heading');
	var heading3 = document.createElement('label');
	heading3.setAttribute("value","Allowed");
	heading3.setAttribute('class','heading');
	var heading4 = document.createElement('label');
	heading4.setAttribute("value","Remaining");
	heading4.setAttribute('class','heading');
	headingRow.appendChild(heading1);
	headingRow.appendChild(heading2);
	headingRow.appendChild(heading3);
	headingRow.appendChild(heading4);
	return headingRow;
}

function createMinuteDataRows(minuteData)
{
	var minutesRows = new Array();
	
	for ( var i=0; i<minuteData.length; i++ )
	{
		var row = document.createElement("row");
		if ( (i % 2) == 0 )
		{
			row.setAttribute("class","stripe");
		}
		rowData = minuteData[i];
		for ( var j=0; j<rowData.length; j++ )
		{
			var element = createDataLabel(removeEncodedAnd(rowData[j]));
			if ( j == 0 )
			{
				element.setAttribute('class','type');
			}
			row.appendChild(element);
		}
		minutesRows[i] = row;
	}
	return minutesRows;
}

function createDataLabel(data)
{
	var label = document.createElement('label');
	label.setAttribute('value',data);
	return label;
}

function removeEncodedAnd( minuteType )
{
	var replacedString = "";
	if ( minuteType )
	{
		minuteType = ""+minuteType;
		replacedString = minuteType.replace(/&amp;/, "&");
	}
	return replacedString;
}

function stripAnchor( minuteType )
{
	var rtnVal = minuteType;
	var regStr = "<a[\\s\\S]*?>([\\s\\S]*?)</a>";
	var regExp = new RegExp(regStr);
	var replacedString = regExp.exec(minuteType);
	if (replacedString && replacedString[1])
	{
		rtnVal = replacedString[1];
	}

	return rtnVal;
}

function countDown()
{
	var image = document.getElementById("cingularImage");
	image.src="chrome://cingularminutes/content/cingularSmall.png";
	setCingularLabel("Could not login to Cingular");
}

function clearLastUsed()
{
//	var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	prefs.deleteBranch("extensions.cingularMinutesMinder.lastTimeChecked");
}

function clear () {
	for(var i=0;i<50;i++){
		print('');
	}
}

function print(str)
{
	dump("\n"+str);
}

cingularInit();